## chewing-editor 0.0.1

=== CMakeLists.txt ===
# chewing-editor: Chewing userphrase editor
# Copyright (C) 2014 Chewing Development Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

cmake_minimum_required(VERSION 3.0.0)
project(chewing-editor VERSION 0.0.0)

set(TRANSLATION_LIST en_US zh_TW)

cmake_policy(SET CMP0020 NEW)

include(GNUInstallDirs)

if(${CMAKE_C_COMPILER_ID} STREQUAL "GNU" OR ${CMAKE_C_COMPILER_ID} STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "-std=c++11 -g -O2 ${CMAKE_CXX_FLAGS}")

    option(ENABLE_GCOV "Coverage support" false)
    if(ENABLE_GCOV)
        set(CMAKE_CXX_FLAGS "-coverage ${CMAKE_CXX_FLAGS}")
    endif()

    find_program(VALGRIND valgrind)
    if (VALGRIND)
        option(USE_VALGRIND "Use valgrind when testing" true)
    endif()

    set(TRANSLATION_PATH ${CMAKE_INSTALL_DATADIR}/chewing-editor/translations)

    add_definitions(-DTRANSLATION_PATH="${TRANSLATION_PATH}")
else()
    # FIXME: Windows TRANSLATION_PATH path is?
    #add_definitions(-DTRANSLATION_PATH="???")
endif()
add_definitions(-DTESTDATA="${PROJECT_SOURCE_DIR}/test/data")

find_package(PkgConfig)

set(CHEWING_LIBRARIES )
set(CHEWING_INCLUDE_DIRS )

if (CHEWING_INCLUDE_DIRS AND CHEWING_LIBRARIES)
    # if all listed variables are TRUE
    find_package_handle_standard_args(chewing DEFAULT_MSG CHEWING_LIBRARIES CHEWING_INCLUDE_DIRS)
    mark_as_advanced(CHEWING_LIBRARIES CHEWING_INCLUDE_DIRS)
else()
    pkg_check_modules(CHEWING REQUIRED chewing>=0.4.0)
endif()


set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Qt5Widgets REQUIRED)

find_program(LUPDATE lupdate)
if (NOT LUPDATE)
    message(SEND_ERROR "Cannot find lupdate")
endif()

find_program(LRELEASE lrelease)
if (NOT LRELEASE)
    message(SEND_ERROR "Cannot find lrelease")
endif()

configure_file(
    ${PROJECT_SOURCE_DIR}/config.h.in
    ${PROJECT_BINARY_DIR}/include/config.h
)

configure_file(
    ${PROJECT_SOURCE_DIR}/chewing-editor.desktop.in
    ${PROJECT_BINARY_DIR}/chewing-editor.desktop
)

install(
    FILES ${PROJECT_BINARY_DIR}/chewing-editor.desktop
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/application
)

include_directories(
    ${PROJECT_BINARY_DIR}/include
    ${PROJECT_SOURCE_DIR}/gmock/gtest/include
    ${PROJECT_SOURCE_DIR}/src/exporter
    ${PROJECT_SOURCE_DIR}/src/importer
    ${PROJECT_SOURCE_DIR}/src/model
    ${PROJECT_SOURCE_DIR}/src/ui
    ${PROJECT_SOURCE_DIR}/src/util
    ${PROJECT_SOURCE_DIR}/src/view
    ${CHEWING_INCLUDE_DIRS}
    ${Qt5Widgets_INCLUDES}
)

# exporter
file(GLOB_RECURSE exporter_src ${PROJECT_SOURCE_DIR}/src/exporter/*)
add_library(exporter STATIC ${exporter_src})
qt5_use_modules(exporter Widgets)

# importer
file(GLOB_RECURSE importer_src ${PROJECT_SOURCE_DIR}/src/importer/*)
add_library(importer STATIC ${importer_src})
qt5_use_modules(importer Widgets)

# ui
file(GLOB ui_src ${PROJECT_SOURCE_DIR}/src/ui/*)
qt5_wrap_ui(ui ${ui_src})

# util
file(GLOB util_src ${PROJECT_SOURCE_DIR}/src/util/*)
add_library(util STATIC ${util_src})
qt5_use_modules(util Widgets)

# chewing-editor
file(GLOB chewing-editor_src
    ${PROJECT_SOURCE_DIR}/src/*
    ${PROJECT_SOURCE_DIR}/src/model/*
    ${PROJECT_SOURCE_DIR}/src/ui/*
    ${PROJECT_SOURCE_DIR}/src/view/*
    ${ui}
)
add_executable(chewing-editor ${chewing-editor_src})
target_link_libraries(chewing-editor
    ${CHEWING_LIBRARIES}
    exporter
    importer
    util
)
qt5_use_modules(chewing-editor Widgets)
install(PROGRAMS ${CMAKE_BINARY_DIR}/chewing-editor DESTINATION ${CMAKE_INSTALL_BINDIR})

# icon
install(FILES ${CMAKE_SOURCE_DIR}/share/icons/chewing-editor.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)

# i18n
set(TS_DIR "${PROJECT_SOURCE_DIR}/ts")
set(QM_DIR "${PROJECT_BINARY_DIR}/qm")

add_custom_target(prepare_lupdate
    COMMAND ${CMAKE_COMMAND} -E make_directory ${TS_DIR}
)
add_custom_target(lupdate)

add_custom_target(prepare_lrelease
    COMMAND ${CMAKE_COMMAND} -E make_directory ${QM_DIR}
)

foreach(TRANSLATION ${TRANSLATION_LIST})
    set(TS_FILE "${TS_DIR}/${CMAKE_PROJECT_NAME}_${TRANSLATION}.ts")
    set(QM_FILE "${QM_DIR}/${CMAKE_PROJECT_NAME}_${TRANSLATION}.qm")

    add_custom_target("${TRANSLATION}-ts"
        COMMAND ${LUPDATE} ${PROJECT_SOURCE_DIR}/src -ts ${TS_FILE}
        DEPENDS prepare_lupdate
    )
    add_dependencies(lupdate "${TRANSLATION}-ts")

    add_custom_command(
        OUTPUT
            ${QM_FILE}
        COMMAND ${LRELEASE} ${TS_FILE} -qm ${QM_FILE}
        DEPENDS
            prepare_lrelease
            ${TS_FILE}
    )
    list(APPEND QM_FILES ${QM_FILE})
endforeach()

add_custom_target(lrelease ALL DEPENDS ${QM_FILES})
install(FILES ${QM_FILES} DESTINATION ${TRANSLATION_PATH})

# manpage
find_program(HELP2MAN help2man)

if (HELP2MAN)
    set(manpage ${PROJECT_BINARY_DIR}/chewing-editor.1.gz)
    set(h2m ${PROJECT_SOURCE_DIR}/chewing-editor.h2m)

    add_custom_command(
        OUTPUT
            ${manpage}
        COMMAND ${HELP2MAN}
            --include=${h2m}
            --section=1
            --no-info
            --no-discard-stderr
            --output=${manpage}
            ${PROJECT_BINARY_DIR}/chewing-editor
        DEPENDS
            chewing-editor
            ${h2m}
    )

    add_custom_target(manpage ALL DEPENDS ${manpage})

    install(FILES ${manpage} DESTINATION "${CMAKE_INSTALL_MANDIR}/man1/")
endif()

# testing
enable_testing()
add_subdirectory(gmock)

file(GLOB run-test_src
    test/*.cpp
)
add_executable(run-test
    ${run-test_src}
)
target_link_libraries(run-test
    gmock

    exporter
    importer
    util
)
qt5_use_modules(run-test Widgets)

add_test(test run-test)

if (USE_VALGRIND)
    add_test("valgrind-run-test" ${VALGRIND} --error-exitcode=255 --leak-check=full ${PROJECT_BINARY_DIR}/run-test)
endif()

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
add_dependencies(check chewing-editor run-test)

# package
set(CPACK_SOURCE_GENERATOR TGZ)
set(CPACK_SOURCE_IGNORE_FILES
    "^${PROJECT_SOURCE_DIR}/.git"
)

set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})

include(CPack)

=== debian/changelog ===
chewing-editor (0.0.1-3) unstable; urgency=medium

  * Add missing copyright for debian/*.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 10 Feb 2016 01:34:46 +0800

chewing-editor (0.0.1-2) unstable; urgency=medium

  * Bump Standards-Version to 3.9.7.
  * Update copyright.
  * Update Vcs-* fields.
  * Update package description.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 08 Feb 2016 23:17:20 +0800

chewing-editor (0.0.1-1) unstable; urgency=low

  * Initial release. Closes: #809014

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 26 Dec 2015 14:45:26 +0800

=== debian/control ===
Source: chewing-editor
Section: x11
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
Build-Depends: cmake (>= 3.0.0),
               debhelper (>= 9.20151219),
               help2man,
               libchewing3-dev (>= 0.4.0),
               pkg-config,
               qtchooser,
               qttools5-dev,
               qttools5-dev-tools,
Standards-Version: 3.9.7
Homepage: https://github.com/chewing/chewing-editor
Vcs-Git: https://anonscm.debian.org/cgit/pkg-ime/chewing-editor.git -b debian/sid
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ime/chewing-editor.git/?h=debian/sid

Package: chewing-editor
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: user dictionary editor for the chewing input method
 chewing-editor is a cross platform user dictionary editor for the chewing
 input method. It provides an easy way to customize user dictionary so that
 chewing input method can take advantage of the user dictionary and provide a
 better input experience.

## chewing-editor 0.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,10 +15,12 @@
 # with this program; if not, write to the Free Software Foundation, Inc.,
 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 
+# override default c/c++ flags, add /MT to link VC++ runtime statically.
+set(CMAKE_USER_MAKE_RULES_OVERRIDE	${CMAKE_CURRENT_SOURCE_DIR}/cmake/c_flag_overrides.cmake)
+set(CMAKE_USER_MAKE_RULES_OVERRIDE_CXX	${CMAKE_CURRENT_SOURCE_DIR}/cmake/cxx_flag_overrides.cmake)
+
 cmake_minimum_required(VERSION 3.0.0)
-project(chewing-editor VERSION 0.0.0)
-
-set(TRANSLATION_LIST en_US zh_TW)
+project(chewing-editor VERSION 0.1.1)
 
 cmake_policy(SET CMP0020 NEW)
 
@@ -36,19 +38,29 @@
     if (VALGRIND)
         option(USE_VALGRIND "Use valgrind when testing" true)
     endif()
-
-    set(TRANSLATION_PATH ${CMAKE_INSTALL_DATADIR}/chewing-editor/translations)
-
-    add_definitions(-DTRANSLATION_PATH="${TRANSLATION_PATH}")
-else()
-    # FIXME: Windows TRANSLATION_PATH path is?
-    #add_definitions(-DTRANSLATION_PATH="???")
-endif()
+elseif(MSVC)
+    # MBCS is the default in msvc, overwrite to unicode
+    add_definitions(-DUNICODE -D_UNICODE)
+endif()
+
 add_definitions(-DTESTDATA="${PROJECT_SOURCE_DIR}/test/data")
 
 find_package(PkgConfig)
-
+find_package(Qt5Widgets REQUIRED)
+
+find_program(LUPDATE lupdate)
+if (NOT LUPDATE)
+    message(SEND_ERROR "Cannot find lupdate")
+endif()
+find_program(LRELEASE lrelease)
+if (NOT LRELEASE)
+    message(SEND_ERROR "Cannot find lrelease")
+endif()
+
+# libchewing
+# MODIFY IF NEEDED, e.g. ${CMAKE_CURRENT_SOURCE_DIR}/libchewing/lib/*.lib
 set(CHEWING_LIBRARIES )
+# MODIFY IF NEEDED, e.g. ${CMAKE_CURRENT_SOURCE_DIR}/libchewing/include/chewing
 set(CHEWING_INCLUDE_DIRS )
 
 if (CHEWING_INCLUDE_DIRS AND CHEWING_LIBRARIES)
@@ -59,20 +71,27 @@
     pkg_check_modules(CHEWING REQUIRED chewing>=0.4.0)
 endif()
 
-
+# Qt library
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
-find_package(Qt5Widgets REQUIRED)
-
-find_program(LUPDATE lupdate)
-if (NOT LUPDATE)
-    message(SEND_ERROR "Cannot find lupdate")
-endif()
-
-find_program(LRELEASE lrelease)
-if (NOT LRELEASE)
-    message(SEND_ERROR "Cannot find lrelease")
+# Git describe
+find_package(Git)
+if (GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git/HEAD")
+    execute_process(
+        COMMAND
+            ${GIT_EXECUTABLE}
+            describe
+            --tags
+        WORKING_DIRECTORY
+            ${PROJECT_SOURCE_DIR}
+        RESULT_VARIABLE
+            git_describe_result
+        OUTPUT_VARIABLE
+            PROJECT_GIT_VERSION
+        ERROR_QUIET
+        OUTPUT_STRIP_TRAILING_WHITESPACE
+    )
 endif()
 
 configure_file(
@@ -87,7 +106,7 @@
 
 install(
     FILES ${PROJECT_BINARY_DIR}/chewing-editor.desktop
-    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/application
+    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications
 )
 
 include_directories(
@@ -103,6 +122,50 @@
     ${Qt5Widgets_INCLUDES}
 )
 
+include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/platform_apple.cmake)
+
+# resources
+QT5_ADD_RESOURCES(qt_resources ${PROJECT_SOURCE_DIR}/rc/resources.qrc)
+
+# i18n
+set(TRANSLATION_LIST en_US zh_TW)
+
+set(TS_DIR "${PROJECT_SOURCE_DIR}/ts")
+set(QM_DIR "${PROJECT_SOURCE_DIR}/ts")
+
+add_custom_target(prepare_lupdate
+    COMMAND ${CMAKE_COMMAND} -E make_directory ${TS_DIR}
+)
+add_custom_target(lupdate)
+
+add_custom_target(prepare_lrelease
+    COMMAND ${CMAKE_COMMAND} -E make_directory ${QM_DIR}
+)
+
+foreach(TRANSLATION ${TRANSLATION_LIST})
+    set(TS_FILE "${TS_DIR}/${CMAKE_PROJECT_NAME}_${TRANSLATION}.ts")
+    set(QM_FILE "${QM_DIR}/${CMAKE_PROJECT_NAME}_${TRANSLATION}.qm")
+
+    add_custom_target("${TRANSLATION}-ts"
+        COMMAND ${LUPDATE} ${PROJECT_SOURCE_DIR}/src -ts ${TS_FILE}
+        DEPENDS prepare_lupdate
+    )
+    add_dependencies(lupdate "${TRANSLATION}-ts")
+
+    add_custom_command(
+        OUTPUT
+            ${QM_FILE}
+        COMMAND ${LRELEASE} ${TS_FILE} -qm ${QM_FILE}
+        DEPENDS
+            prepare_lrelease
+            ${TS_FILE}
+    )
+    list(APPEND QM_FILES ${QM_FILE})
+endforeach()
+
+add_custom_target(lrelease ALL DEPENDS ${QM_FILES})
+QT5_ADD_RESOURCES(qt_resources ${PROJECT_SOURCE_DIR}/ts/ts.qrc)
+
 # exporter
 file(GLOB_RECURSE exporter_src ${PROJECT_SOURCE_DIR}/src/exporter/*)
 add_library(exporter STATIC ${exporter_src})
@@ -130,61 +193,40 @@
     ${PROJECT_SOURCE_DIR}/src/view/*
     ${ui}
 )
-add_executable(chewing-editor ${chewing-editor_src})
+add_executable(chewing-editor WIN32 ${MACOSX_APP} ${chewing-editor_src} ${qt_resources} ${PROJECT_SOURCE_DIR}/rc/chewing-editor.rc) # on Windows, remove "WIN32" for a console window
 target_link_libraries(chewing-editor
     ${CHEWING_LIBRARIES}
     exporter
     importer
     util
 )
+if(MSVC)
+    target_link_libraries(chewing-editor  # append libraries
+        Qt5::Widgets
+        "${_qt5Widgets_install_prefix}/lib/qtpcre.lib"
+        "${_qt5Widgets_install_prefix}/lib/qtfreetype.lib"
+        "${_qt5Widgets_install_prefix}/lib/qtharfbuzzng.lib"
+        "${_qt5Widgets_install_prefix}/lib/Qt5PlatformSupport.lib"
+        "${_qt5Widgets_install_prefix}/plugins/platforms/qwindows.lib"
+        imm32.lib
+        winmm.lib
+        Ws2_32.lib
+    )
+endif()
+
 qt5_use_modules(chewing-editor Widgets)
 install(PROGRAMS ${CMAKE_BINARY_DIR}/chewing-editor DESTINATION ${CMAKE_INSTALL_BINDIR})
 
 # icon
 install(FILES ${CMAKE_SOURCE_DIR}/share/icons/chewing-editor.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
-
-# i18n
-set(TS_DIR "${PROJECT_SOURCE_DIR}/ts")
-set(QM_DIR "${PROJECT_BINARY_DIR}/qm")
-
-add_custom_target(prepare_lupdate
-    COMMAND ${CMAKE_COMMAND} -E make_directory ${TS_DIR}
-)
-add_custom_target(lupdate)
-
-add_custom_target(prepare_lrelease
-    COMMAND ${CMAKE_COMMAND} -E make_directory ${QM_DIR}
-)
-
-foreach(TRANSLATION ${TRANSLATION_LIST})
-    set(TS_FILE "${TS_DIR}/${CMAKE_PROJECT_NAME}_${TRANSLATION}.ts")
-    set(QM_FILE "${QM_DIR}/${CMAKE_PROJECT_NAME}_${TRANSLATION}.qm")
-
-    add_custom_target("${TRANSLATION}-ts"
-        COMMAND ${LUPDATE} ${PROJECT_SOURCE_DIR}/src -ts ${TS_FILE}
-        DEPENDS prepare_lupdate
-    )
-    add_dependencies(lupdate "${TRANSLATION}-ts")
-
-    add_custom_command(
-        OUTPUT
-            ${QM_FILE}
-        COMMAND ${LRELEASE} ${TS_FILE} -qm ${QM_FILE}
-        DEPENDS
-            prepare_lrelease
-            ${TS_FILE}
-    )
-    list(APPEND QM_FILES ${QM_FILE})
-endforeach()
-
-add_custom_target(lrelease ALL DEPENDS ${QM_FILES})
-install(FILES ${QM_FILES} DESTINATION ${TRANSLATION_PATH})
+install(FILES ${CMAKE_SOURCE_DIR}/rc/chewing-editor.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/256/apps)
 
 # manpage
 find_program(HELP2MAN help2man)
+find_program(GZIP gzip)
 
 if (HELP2MAN)
-    set(manpage ${PROJECT_BINARY_DIR}/chewing-editor.1.gz)
+    set(manpage ${PROJECT_BINARY_DIR}/chewing-editor.1)
     set(h2m ${PROJECT_SOURCE_DIR}/chewing-editor.h2m)
 
     add_custom_command(
@@ -202,6 +244,20 @@
             ${h2m}
     )
 
+    if (GZIP)
+        add_custom_command(
+            OUTPUT
+                ${manpage}.gz
+            COMMAND ${GZIP}
+                -f
+                ${manpage}
+            DEPENDS
+                ${manpage}
+        )
+
+        set(manpage ${manpage}.gz)
+    endif()
+
     add_custom_target(manpage ALL DEPENDS ${manpage})
 
     install(FILES ${manpage} DESTINATION "${CMAKE_INSTALL_MANDIR}/man1/")
@@ -223,6 +279,7 @@
     exporter
     importer
     util
+    pthread
 )
 qt5_use_modules(run-test Widgets)

=== debian/changelog ===
chewing-editor (0.1.1-6) unstable; urgency=medium

  * Team upload.
  * debian/control: Update build-dependency pkg-config => pkgconf.
  * debian/upstream/metadata: Added following Debian Janitor MR.
  * debian/control: Update build-dependency requirement following
    Debian Janitor MR.

 -- Boyuan Yang <byang@debian.org>  Thu, 04 Jul 2024 22:06:06 -0400

chewing-editor (0.1.1-5) unstable; urgency=medium

  * Team upload.
  * debian/clean: Manually clean generated .qm files to avoid
    fails to build source after successful build. (Closes: #1043646)

 -- Boyuan Yang <byang@debian.org>  Sun, 13 Aug 2023 09:50:50 -0400

chewing-editor (0.1.1-4) unstable; urgency=medium

  * Team upload.
  * Backport upstream trunk code till 2020-10-20.
  * Refresh packaging:
    + Bump Standards-Version to 4.6.1.
    + Bump debhelper compat to v13.
  * debian/rules: Drop useless "dh_missing --fail-missing" with dh13.
  * debian/uscan: Fix upstream monitoring.
  * debian/source/local-options: Dropped, useless.

 -- Boyuan Yang <byang@debian.org>  Sun, 18 Sep 2022 15:25:55 -0400

chewing-editor (0.1.1-3) unstable; urgency=medium

  * Team upload.
  * debian/patches: Backport upstream trunk code till 2017-05-30.
  * debian/control:
    + Bump debhelper compat to v11.
    + Bump Standards-Version to 4.2.1.
    + Update Vcs fields and use the repo under debian input-method-team.
  * debian/rules: Use "dh_missing --fail-missing".
  * debian/copyright: Use secure uri.

 -- Boyuan Yang <byang@debian.org>  Tue, 04 Sep 2018 15:20:29 -0400

chewing-editor (0.1.1-2) unstable; urgency=medium

  * Bump Standards-Version to 4.1.4.
    * Change to https in Format in d/copyright.
  * Bump compat to 11.
  * Update Maintainer mail address. (Closes: #899471)
  * Update Vcs-* fields to salsa.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 29 May 2018 23:04:28 +0800

chewing-editor (0.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 24 Apr 2016 19:45:36 +0800

chewing-editor (0.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 3.9.8.
  * Update Vcs-* fields.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 16 Apr 2016 14:53:16 +0800

chewing-editor (0.0.4-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 04 Apr 2016 18:04:21 +0800

chewing-editor (0.0.3-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Fri, 25 Mar 2016 19:29:21 +0800

chewing-editor (0.0.2-1) unstable; urgency=medium

  * New upstream release. Closes: #814308
  * Remove unused version patch.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 05 Mar 2016 00:05:51 +0800

=== debian/control ===
Source: chewing-editor
Section: x11
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 help2man,
 libchewing3-dev,
 pkgconf,
 qtchooser,
 qttools5-dev,
 qttools5-dev-tools,
Standards-Version: 4.7.0
Homepage: https://github.com/chewing/chewing-editor
Vcs-Git: https://salsa.debian.org/input-method-team/chewing-editor.git
Vcs-Browser: https://salsa.debian.org/input-method-team/chewing-editor

Package: chewing-editor
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: user dictionary editor for the chewing input method
 chewing-editor is a cross platform user dictionary editor for the chewing
 input method. It provides an easy way to customize user dictionary so that
 chewing input method can take advantage of the user dictionary and provide a
 better input experience.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

export QT_SELECT := 5

%:
	dh $@

execute_after_dh_auto_install:
	rm -r debian/chewing-editor/usr/share/man

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
 https://github.com/chewing/chewing-editor/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## chewing-editor 0.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,19 +19,19 @@
 set(CMAKE_USER_MAKE_RULES_OVERRIDE	${CMAKE_CURRENT_SOURCE_DIR}/cmake/c_flag_overrides.cmake)
 set(CMAKE_USER_MAKE_RULES_OVERRIDE_CXX	${CMAKE_CURRENT_SOURCE_DIR}/cmake/cxx_flag_overrides.cmake)
 
-cmake_minimum_required(VERSION 3.0.0)
-project(chewing-editor VERSION 0.1.1)
-
-cmake_policy(SET CMP0020 NEW)
+cmake_minimum_required(VERSION 3.10.0...3.31.6)
+project(chewing-editor VERSION 0.1.2 LANGUAGES CXX)
+
+set(CMAKE_CXX_STANDARD 17)
 
 include(GNUInstallDirs)
 
-if(${CMAKE_C_COMPILER_ID} STREQUAL "GNU" OR ${CMAKE_C_COMPILER_ID} STREQUAL "Clang")
-    set(CMAKE_CXX_FLAGS "-std=c++11 -g -O2 ${CMAKE_CXX_FLAGS}")
+if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU" OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
+    set(CMAKE_CXX_FLAGS "-g -O2 ${CMAKE_CXX_FLAGS}")
 
     option(ENABLE_GCOV "Coverage support" false)
     if(ENABLE_GCOV)
-        set(CMAKE_CXX_FLAGS "-coverage ${CMAKE_CXX_FLAGS}")
+        set(CMAKE_CXX_FLAGS "--coverage ${CMAKE_CXX_FLAGS}")
     endif()
 
     find_program(VALGRIND valgrind)
@@ -43,27 +43,21 @@
     add_definitions(-DUNICODE -D_UNICODE)
 endif()
 
-add_definitions(-DTESTDATA="${PROJECT_SOURCE_DIR}/test/data")
+add_definitions(-DTESTDATA="${PROJECT_SOURCE_DIR}/test/data" -DQT_DISABLE_DEPRECATED_BEFORE=0x050e00)
 
 find_package(PkgConfig)
 find_package(Qt5Widgets REQUIRED)
-
-find_program(LUPDATE lupdate)
-if (NOT LUPDATE)
-    message(SEND_ERROR "Cannot find lupdate")
-endif()
-find_program(LRELEASE lrelease)
-if (NOT LRELEASE)
-    message(SEND_ERROR "Cannot find lrelease")
-endif()
+find_package(Qt5LinguistTools)
 
 # libchewing
+# MODIFY IF NEEDED, e.g. ${CMAKE_CURRENT_SOURCE_DIR}/libchewing/lib/
+set(CHEWING_LIBRARY_DIRS )
 # MODIFY IF NEEDED, e.g. ${CMAKE_CURRENT_SOURCE_DIR}/libchewing/lib/*.lib
 set(CHEWING_LIBRARIES )
 # MODIFY IF NEEDED, e.g. ${CMAKE_CURRENT_SOURCE_DIR}/libchewing/include/chewing
 set(CHEWING_INCLUDE_DIRS )
 
-if (CHEWING_INCLUDE_DIRS AND CHEWING_LIBRARIES)
+if (CHEWING_INCLUDE_DIRS AND CHEWING_LIBRARIES AND CHEWING_LIBRARY_DIRS)
     # if all listed variables are TRUE
     find_package_handle_standard_args(chewing DEFAULT_MSG CHEWING_LIBRARIES CHEWING_INCLUDE_DIRS)
     mark_as_advanced(CHEWING_LIBRARIES CHEWING_INCLUDE_DIRS)
@@ -71,9 +65,12 @@
     pkg_check_modules(CHEWING REQUIRED chewing>=0.4.0)
 endif()
 
+pkg_check_modules(GTEST REQUIRED gtest>=1.7.0 IMPORTED_TARGET)
+
 # Qt library
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
+set(QT_VERSION 5)
 
 # Git describe
 find_package(Git)
@@ -99,19 +96,13 @@
     ${PROJECT_BINARY_DIR}/include/config.h
 )
 
-configure_file(
-    ${PROJECT_SOURCE_DIR}/chewing-editor.desktop.in
-    ${PROJECT_BINARY_DIR}/chewing-editor.desktop
-)
-
 install(
-    FILES ${PROJECT_BINARY_DIR}/chewing-editor.desktop
+    FILES ${PROJECT_SOURCE_DIR}/chewing-editor.desktop
     DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications
 )
 
 include_directories(
     ${PROJECT_BINARY_DIR}/include
-    ${PROJECT_SOURCE_DIR}/gmock/gtest/include
     ${PROJECT_SOURCE_DIR}/src/exporter
     ${PROJECT_SOURCE_DIR}/src/importer
     ${PROJECT_SOURCE_DIR}/src/model
@@ -122,6 +113,8 @@
     ${Qt5Widgets_INCLUDES}
 )
 
+link_directories(${CHEWING_LIBRARY_DIRS})
+
 include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/platform_apple.cmake)
 
 # resources
@@ -147,7 +140,7 @@
     set(QM_FILE "${QM_DIR}/${CMAKE_PROJECT_NAME}_${TRANSLATION}.qm")
 
     add_custom_target("${TRANSLATION}-ts"
-        COMMAND ${LUPDATE} ${PROJECT_SOURCE_DIR}/src -ts ${TS_FILE}
+        COMMAND ${Qt5_LUPDATE_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src -ts ${TS_FILE}
         DEPENDS prepare_lupdate
     )
     add_dependencies(lupdate "${TRANSLATION}-ts")
@@ -155,7 +148,7 @@
     add_custom_command(
         OUTPUT
             ${QM_FILE}
-        COMMAND ${LRELEASE} ${TS_FILE} -qm ${QM_FILE}
+        COMMAND ${Qt5_LRELEASE_EXECUTABLE} ${TS_FILE} -qm ${QM_FILE}
         DEPENDS
             prepare_lrelease
             ${TS_FILE}
@@ -169,12 +162,12 @@
 # exporter
 file(GLOB_RECURSE exporter_src ${PROJECT_SOURCE_DIR}/src/exporter/*)
 add_library(exporter STATIC ${exporter_src})
-qt5_use_modules(exporter Widgets)
+target_link_libraries(exporter Qt5::Widgets)
 
 # importer
 file(GLOB_RECURSE importer_src ${PROJECT_SOURCE_DIR}/src/importer/*)
 add_library(importer STATIC ${importer_src})
-qt5_use_modules(importer Widgets)
+target_link_libraries(importer Qt5::Widgets)
 
 # ui
 file(GLOB ui_src ${PROJECT_SOURCE_DIR}/src/ui/*)
@@ -183,7 +176,7 @@
 # util
 file(GLOB util_src ${PROJECT_SOURCE_DIR}/src/util/*)
 add_library(util STATIC ${util_src})
-qt5_use_modules(util Widgets)
+target_link_libraries(util Qt5::Widgets)
 
 # chewing-editor
 file(GLOB chewing-editor_src
@@ -214,12 +207,12 @@
     )
 endif()
 
-qt5_use_modules(chewing-editor Widgets)
+target_link_libraries(chewing-editor Qt5::Widgets)
 install(PROGRAMS ${CMAKE_BINARY_DIR}/chewing-editor DESTINATION ${CMAKE_INSTALL_BINDIR})
 
 # icon
 install(FILES ${CMAKE_SOURCE_DIR}/share/icons/chewing-editor.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
-install(FILES ${CMAKE_SOURCE_DIR}/rc/chewing-editor.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/256/apps)
+install(FILES ${CMAKE_SOURCE_DIR}/rc/chewing-editor.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/256x256/apps)
 
 # manpage
 find_program(HELP2MAN help2man)
@@ -249,7 +242,7 @@
             OUTPUT
                 ${manpage}.gz
             COMMAND ${GZIP}
-                -f
+                -n -f
                 ${manpage}
             DEPENDS
                 ${manpage}
@@ -265,7 +258,6 @@
 
 # testing
 enable_testing()
-add_subdirectory(gmock)
 
 file(GLOB run-test_src
     test/*.cpp
@@ -274,14 +266,14 @@
     ${run-test_src}
 )
 target_link_libraries(run-test
-    gmock
+    PkgConfig::GTEST
 
     exporter
     importer
     util
     pthread
 )
-qt5_use_modules(run-test Widgets)
+target_link_libraries(run-test Qt5::Widgets)
 
 add_test(test run-test)
 
@@ -296,6 +288,8 @@
 set(CPACK_SOURCE_GENERATOR TGZ)
 set(CPACK_SOURCE_IGNORE_FILES
     "^${PROJECT_SOURCE_DIR}/.git"
+    "^${PROJECT_SOURCE_DIR}/.jj"
+    "^${PROJECT_SOURCE_DIR}/build"
 )
 
 set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})

=== debian/changelog ===
chewing-editor (0.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Use upstream manpage.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 27 Jul 2025 01:58:39 +0800

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
  debhelper-compat (= 13),
  help2man,
  libchewing3-dev,
+ libgtest-dev,
  pkgconf,
  qtchooser,
  qttools5-dev,

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,3 @@
 
 %:
 	dh $@
-
-execute_after_dh_auto_install:
-	rm -r debian/chewing-editor/usr/share/man
